<script lang="ts">
	import { browser } from '$app/environment';
	import { utils } from '@higenku/theme';
	import {Skeleton, SkeletonBox} from '@higenku/theme';

    
    interface Contributor {
        name: string;
        avatar: string;
    }

	let loading = true;
	let contributors: Contributor[];

	const fetchData = async () => {
		try {
			const res = await fetch(
				`https://static.higenku.org/https://api.github.com/repos/higenku/atributions/contributors`
			);
			const data = await res.json();
			contributors = data.map((s: any) => ({
				name: s.login,
				avatar: s.avatar_url
			}));
			loading = false;
		} catch (e) {
			utils.newNotification(
				'An error happened',
				'We could not load contributors',
				true,
				'erro'
			);
			console.log(e);
		}
	};

	if (browser) {
		fetchData();
	}
</script>

<h2>Thanks to our Contributors!</h2>

{#if loading}
    <div class="grid gap-1" style="grid-template-columns: repeat(auto-fit, 115px);">
		{#each Array(3) as co}
			<div class="col-2 col-sm-5">
				<div class="card" style="width: 250px;">
					<SkeletonBox size="lg" classes="avatar squared"/>
                    <div class="pt-1">
                        <Skeleton lineCount={2} />
                    </div>
				</div>
			</div>
		{/each}
	</div>
{:else}
	<div class="grid gap-1" style="grid-template-columns: repeat(auto-fit, 115px);">
		{#each contributors as co}
			<div class="col-2 col-sm-5">
				<div class="card" style="min-width: 100px;">
					<img class="avatar squared lg" src={co.avatar} alt="{co.name} Picture" />

					<a href="https://github.com/{co.name}">
						<h4>{co.name}</h4>
					</a>
				</div>
			</div>
		{/each}
	</div>
{/if}

<style>
	@media screen and (max-width: 600px) {
		.col-sm-5 {
			grid-column: span 5;
		}
	}
</style>
